git-stash.shon commit Merge branch 'jc/color-attrs' into maint (0476228)
   1#!/bin/sh
   2# Copyright (c) 2007, Nanako Shiraishi
   3
   4dashless=$(basename "$0" | sed -e 's/-/ /')
   5USAGE="list [<options>]
   6   or: $dashless show [<stash>]
   7   or: $dashless drop [-q|--quiet] [<stash>]
   8   or: $dashless ( pop | apply ) [--index] [-q|--quiet] [<stash>]
   9   or: $dashless branch <branchname> [<stash>]
  10   or: $dashless [save [--patch] [-k|--[no-]keep-index] [-q|--quiet] [<message>]]
  11   or: $dashless clear"
  12
  13SUBDIRECTORY_OK=Yes
  14OPTIONS_SPEC=
  15. git-sh-setup
  16require_work_tree
  17cd_to_toplevel
  18
  19TMP="$GIT_DIR/.git-stash.$$"
  20trap 'rm -f "$TMP-*"' 0
  21
  22ref_stash=refs/stash
  23
  24if git config --get-colorbool color.interactive; then
  25       help_color="$(git config --get-color color.interactive.help 'red bold')"
  26       reset_color="$(git config --get-color '' reset)"
  27else
  28       help_color=
  29       reset_color=
  30fi
  31
  32no_changes () {
  33        git diff-index --quiet --cached HEAD --ignore-submodules -- &&
  34        git diff-files --quiet --ignore-submodules
  35}
  36
  37clear_stash () {
  38        if test $# != 0
  39        then
  40                die "git stash clear with parameters is unimplemented"
  41        fi
  42        if current=$(git rev-parse --verify $ref_stash 2>/dev/null)
  43        then
  44                git update-ref -d $ref_stash $current
  45        fi
  46}
  47
  48create_stash () {
  49        stash_msg="$1"
  50
  51        git update-index -q --refresh
  52        if no_changes
  53        then
  54                exit 0
  55        fi
  56
  57        # state of the base commit
  58        if b_commit=$(git rev-parse --verify HEAD)
  59        then
  60                head=$(git log --no-color --abbrev-commit --pretty=oneline -n 1 HEAD --)
  61        else
  62                die "You do not have the initial commit yet"
  63        fi
  64
  65        if branch=$(git symbolic-ref -q HEAD)
  66        then
  67                branch=${branch#refs/heads/}
  68        else
  69                branch='(no branch)'
  70        fi
  71        msg=$(printf '%s: %s' "$branch" "$head")
  72
  73        # state of the index
  74        i_tree=$(git write-tree) &&
  75        i_commit=$(printf 'index on %s\n' "$msg" |
  76                git commit-tree $i_tree -p $b_commit) ||
  77                die "Cannot save the current index state"
  78
  79        if test -z "$patch_mode"
  80        then
  81
  82                # state of the working tree
  83                w_tree=$( (
  84                        rm -f "$TMP-index" &&
  85                        cp -p ${GIT_INDEX_FILE-"$GIT_DIR/index"} "$TMP-index" &&
  86                        GIT_INDEX_FILE="$TMP-index" &&
  87                        export GIT_INDEX_FILE &&
  88                        git read-tree -m $i_tree &&
  89                        git add -u &&
  90                        git write-tree &&
  91                        rm -f "$TMP-index"
  92                ) ) ||
  93                        die "Cannot save the current worktree state"
  94
  95        else
  96
  97                rm -f "$TMP-index" &&
  98                GIT_INDEX_FILE="$TMP-index" git read-tree HEAD &&
  99
 100                # find out what the user wants
 101                GIT_INDEX_FILE="$TMP-index" \
 102                        git add--interactive --patch=stash -- &&
 103
 104                # state of the working tree
 105                w_tree=$(GIT_INDEX_FILE="$TMP-index" git write-tree) ||
 106                die "Cannot save the current worktree state"
 107
 108                git diff-tree -p HEAD $w_tree > "$TMP-patch" &&
 109                test -s "$TMP-patch" ||
 110                die "No changes selected"
 111
 112                rm -f "$TMP-index" ||
 113                die "Cannot remove temporary index (can't happen)"
 114
 115        fi
 116
 117        # create the stash
 118        if test -z "$stash_msg"
 119        then
 120                stash_msg=$(printf 'WIP on %s' "$msg")
 121        else
 122                stash_msg=$(printf 'On %s: %s' "$branch" "$stash_msg")
 123        fi
 124        w_commit=$(printf '%s\n' "$stash_msg" |
 125                git commit-tree $w_tree -p $b_commit -p $i_commit) ||
 126                die "Cannot record working tree state"
 127}
 128
 129save_stash () {
 130        keep_index=
 131        patch_mode=
 132        while test $# != 0
 133        do
 134                case "$1" in
 135                -k|--keep-index)
 136                        keep_index=t
 137                        ;;
 138                --no-keep-index)
 139                        keep_index=
 140                        ;;
 141                -p|--patch)
 142                        patch_mode=t
 143                        keep_index=t
 144                        ;;
 145                -q|--quiet)
 146                        GIT_QUIET=t
 147                        ;;
 148                --)
 149                        shift
 150                        break
 151                        ;;
 152                -*)
 153                        echo "error: unknown option for 'stash save': $1"
 154                        echo "       To provide a message, use git stash save -- '$1'"
 155                        usage
 156                        ;;
 157                *)
 158                        break
 159                        ;;
 160                esac
 161                shift
 162        done
 163
 164        stash_msg="$*"
 165
 166        git update-index -q --refresh
 167        if no_changes
 168        then
 169                say 'No local changes to save'
 170                exit 0
 171        fi
 172        test -f "$GIT_DIR/logs/$ref_stash" ||
 173                clear_stash || die "Cannot initialize stash"
 174
 175        create_stash "$stash_msg"
 176
 177        # Make sure the reflog for stash is kept.
 178        : >>"$GIT_DIR/logs/$ref_stash"
 179
 180        git update-ref -m "$stash_msg" $ref_stash $w_commit ||
 181                die "Cannot save the current status"
 182        say Saved working directory and index state "$stash_msg"
 183
 184        if test -z "$patch_mode"
 185        then
 186                git reset --hard ${GIT_QUIET:+-q}
 187
 188                if test -n "$keep_index" && test -n $i_tree
 189                then
 190                        git read-tree --reset -u $i_tree
 191                fi
 192        else
 193                git apply -R < "$TMP-patch" ||
 194                die "Cannot remove worktree changes"
 195
 196                if test -z "$keep_index"
 197                then
 198                        git reset
 199                fi
 200        fi
 201}
 202
 203have_stash () {
 204        git rev-parse --verify $ref_stash >/dev/null 2>&1
 205}
 206
 207list_stash () {
 208        have_stash || return 0
 209        git log --format="%gd: %gs" -g "$@" $ref_stash --
 210}
 211
 212show_stash () {
 213        flags=$(git rev-parse --no-revs --flags "$@")
 214        if test -z "$flags"
 215        then
 216                flags=--stat
 217        fi
 218
 219        w_commit=$(git rev-parse --verify --default $ref_stash "$@") &&
 220        b_commit=$(git rev-parse --verify "$w_commit^") &&
 221        git diff $flags $b_commit $w_commit
 222}
 223
 224apply_stash () {
 225        applied_stash=
 226        unstash_index=
 227
 228        while test $# != 0
 229        do
 230                case "$1" in
 231                --index)
 232                        unstash_index=t
 233                        ;;
 234                -q|--quiet)
 235                        GIT_QUIET=t
 236                        ;;
 237                *)
 238                        break
 239                        ;;
 240                esac
 241                shift
 242        done
 243
 244        if test $# = 0
 245        then
 246                have_stash || die 'Nothing to apply'
 247                applied_stash="$ref_stash@{0}"
 248        else
 249                applied_stash="$*"
 250        fi
 251
 252        # stash records the work tree, and is a merge between the
 253        # base commit (first parent) and the index tree (second parent).
 254        s=$(git rev-parse --quiet --verify --default $ref_stash "$@") &&
 255        w_tree=$(git rev-parse --quiet --verify "$s:") &&
 256        b_tree=$(git rev-parse --quiet --verify "$s^1:") &&
 257        i_tree=$(git rev-parse --quiet --verify "$s^2:") ||
 258                die "$*: no valid stashed state found"
 259
 260        git update-index -q --refresh &&
 261        git diff-files --quiet --ignore-submodules ||
 262                die 'Cannot apply to a dirty working tree, please stage your changes'
 263
 264        # current index state
 265        c_tree=$(git write-tree) ||
 266                die 'Cannot apply a stash in the middle of a merge'
 267
 268        unstashed_index_tree=
 269        if test -n "$unstash_index" && test "$b_tree" != "$i_tree" &&
 270                        test "$c_tree" != "$i_tree"
 271        then
 272                git diff-tree --binary $s^2^..$s^2 | git apply --cached
 273                test $? -ne 0 &&
 274                        die 'Conflicts in index. Try without --index.'
 275                unstashed_index_tree=$(git write-tree) ||
 276                        die 'Could not save index tree'
 277                git reset
 278        fi
 279
 280        eval "
 281                GITHEAD_$w_tree='Stashed changes' &&
 282                GITHEAD_$c_tree='Updated upstream' &&
 283                GITHEAD_$b_tree='Version stash was based on' &&
 284                export GITHEAD_$w_tree GITHEAD_$c_tree GITHEAD_$b_tree
 285        "
 286
 287        if test -n "$GIT_QUIET"
 288        then
 289                export GIT_MERGE_VERBOSITY=0
 290        fi
 291        if git merge-recursive $b_tree -- $c_tree $w_tree
 292        then
 293                # No conflict
 294                if test -n "$unstashed_index_tree"
 295                then
 296                        git read-tree "$unstashed_index_tree"
 297                else
 298                        a="$TMP-added" &&
 299                        git diff-index --cached --name-only --diff-filter=A $c_tree >"$a" &&
 300                        git read-tree --reset $c_tree &&
 301                        git update-index --add --stdin <"$a" ||
 302                                die "Cannot unstage modified files"
 303                        rm -f "$a"
 304                fi
 305                squelch=
 306                if test -n "$GIT_QUIET"
 307                then
 308                        squelch='>/dev/null 2>&1'
 309                fi
 310                eval "git status $squelch" || :
 311        else
 312                # Merge conflict; keep the exit status from merge-recursive
 313                status=$?
 314                if test -n "$unstash_index"
 315                then
 316                        echo >&2 'Index was not unstashed.'
 317                fi
 318                exit $status
 319        fi
 320}
 321
 322drop_stash () {
 323        have_stash || die 'No stash entries to drop'
 324
 325        while test $# != 0
 326        do
 327                case "$1" in
 328                -q|--quiet)
 329                        GIT_QUIET=t
 330                        ;;
 331                *)
 332                        break
 333                        ;;
 334                esac
 335                shift
 336        done
 337
 338        if test $# = 0
 339        then
 340                set x "$ref_stash@{0}"
 341                shift
 342        fi
 343        # Verify supplied argument looks like a stash entry
 344        s=$(git rev-parse --verify "$@") &&
 345        git rev-parse --verify "$s:"   > /dev/null 2>&1 &&
 346        git rev-parse --verify "$s^1:" > /dev/null 2>&1 &&
 347        git rev-parse --verify "$s^2:" > /dev/null 2>&1 ||
 348                die "$*: not a valid stashed state"
 349
 350        git reflog delete --updateref --rewrite "$@" &&
 351                say "Dropped $* ($s)" || die "$*: Could not drop stash entry"
 352
 353        # clear_stash if we just dropped the last stash entry
 354        git rev-parse --verify "$ref_stash@{0}" > /dev/null 2>&1 || clear_stash
 355}
 356
 357apply_to_branch () {
 358        have_stash || die 'Nothing to apply'
 359
 360        test -n "$1" || die 'No branch name specified'
 361        branch=$1
 362
 363        if test -z "$2"
 364        then
 365                set x "$ref_stash@{0}"
 366        fi
 367        stash=$2
 368
 369        git checkout -b $branch $stash^ &&
 370        apply_stash --index $stash &&
 371        drop_stash $stash
 372}
 373
 374# The default command is "save" if nothing but options are given
 375seen_non_option=
 376for opt
 377do
 378        case "$opt" in
 379        -*) ;;
 380        *) seen_non_option=t; break ;;
 381        esac
 382done
 383
 384test -n "$seen_non_option" || set "save" "$@"
 385
 386# Main command set
 387case "$1" in
 388list)
 389        shift
 390        list_stash "$@"
 391        ;;
 392show)
 393        shift
 394        show_stash "$@"
 395        ;;
 396save)
 397        shift
 398        save_stash "$@"
 399        ;;
 400apply)
 401        shift
 402        apply_stash "$@"
 403        ;;
 404clear)
 405        shift
 406        clear_stash "$@"
 407        ;;
 408create)
 409        if test $# -gt 0 && test "$1" = create
 410        then
 411                shift
 412        fi
 413        create_stash "$*" && echo "$w_commit"
 414        ;;
 415drop)
 416        shift
 417        drop_stash "$@"
 418        ;;
 419pop)
 420        shift
 421        if apply_stash "$@"
 422        then
 423                drop_stash "$applied_stash"
 424        fi
 425        ;;
 426branch)
 427        shift
 428        apply_to_branch "$@"
 429        ;;
 430*)
 431        case $# in
 432        0)
 433                save_stash &&
 434                say '(To restore them type "git stash apply")'
 435                ;;
 436        *)
 437                usage
 438        esac
 439        ;;
 440esac